#include <bits/stdc++.h>
#define debug(x) cout << #x << " is " << x << '\n';
#define stigao() cout << "Stigao\n";

using namespace std;

typedef long long ll;

int n, k, x;
/*
5 5 5
7 17 3
*/
int nope(){
    cout << -1;
    return 0;
}

int solve1(){
    if(n < 3)
        return nope();
    int a[n + 5];
    if(n == 3){
        a[0] = x;
        a[1] = 2 * x;
        a[2] = 4 * x;
        for(int i = 0; i < n; i++){
            cout << a[i] << " ";
        }
        return 0;
    }
    a[n - 1] = 2 * x + 1;
    a[n - 2] = 2 * x;
    a[n - 3] = x + 1;
    a[n - 4] = x;
    for(int i = 0; i < n - 4; i++){
        a[i] = x + 2;
    }
    for(int i = 0; i < n; i++){
        cout << a[i] << " ";
    }
    return 0;
}

int solve2(){
    if(n == 2){
        return nope();
    }
    int a[n + 5];
    a[n - 1] = 3 * x + 1;
    a[n - 2] = 2 * x - 1;
    a[n - 3] = x - 1;
    for(int i = 0; i < n - 3; i++)
        a[i] = x;
    for(int i = 0; i < n; i++)
        cout << a[i] << " ";
    return 0;
}

int solve3(){
    int a[n + 5];
    if(n - 2 >= k){
        for(int i = 0; i < n; i++)
            a[i] = x;
        a[n - 1] = 2 * x - 1;
        for(int i = 0, j = n - 2; i < k; i++){
            a[j - i] = x - 1;
        }
        for(int i = 0; i < n; i++){
            cout << a[i] << " ";
        }
    } else if(n - 1 >= k){
        a[n - 1] = 2 * x + 1;
        for(int i = 0; i < n - 1; i++){
            a[i] = x - 1;
        }
        for(int i = 0; i < n; i++){
            cout << a[i] << " ";
        }
    } else {
        for(int i = 0; i < n; i++)
            a[i] = x;
        int t = k, p = n, alpha = 2 * n;
        while(t >= p - 1){
            a[p - 1] = alpha * x - 1;
            alpha--;
            for(int i = p - 2; i >= 0; i--){
                a[i] = alpha * x - 1;
            }
//            for(int i = 0; i < n; i++)
//                cout << a[i] << " ";
//            cout << '\n';
            t -= p - 1;
            p--;
            alpha--;
        }
//alpha--;
        for(int i = 0, j = p - 1; i < t ; i++, j--){
            a[i] = alpha * x ;
        }
        for(int i = 0; i < n; i++)
            cout << a[i] << " ";
    }
    return 0;
}

int main(){
    ios::sync_with_stdio(0), cin.tie(0), cout.tie(0);
    cin >> n >> k >> x;
    if(n == 1)
        return nope();
    if(k == 3){
        return solve1();
    } else if(n == k){
        return solve2();
    }
    return solve3();
    return 0;
}